/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
package com.rjconsultores.ventaboletos.web.gui.controladores.catalogos;

import com.rjconsultores.ventaboletos.entidad.Moneda;
import com.rjconsultores.ventaboletos.utilerias.ApplicationProperties;
import com.rjconsultores.ventaboletos.web.utilerias.MyGenericForwardComposer;
import com.rjconsultores.ventaboletos.web.utilerias.MyListbox;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.HibernateSearchObject;
import com.rjconsultores.ventaboletos.web.utilerias.paginacion.PagedListWrapper;
import com.rjconsultores.ventaboletos.web.utilerias.render.RenderMoneda;
import java.util.HashMap;
import java.util.Map;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Scope;
import org.springframework.stereotype.Controller;
import org.zkoss.util.resource.Labels;
import org.zkoss.zk.ui.Component;
import org.zkoss.zk.ui.event.Event;
import org.zkoss.zk.ui.event.EventListener;
import org.zkoss.zul.Listheader;
import org.zkoss.zul.Messagebox;
import org.zkoss.zul.Paging;
import org.zkoss.zul.Row;
import org.zkoss.zul.Textbox;

/**
 * 
 * @author Rafius
 */
@Controller("busquedaMonedaController")
@Scope("prototype")
public class BusquedaMonedaController extends MyGenericForwardComposer {

	private static final long serialVersionUID = 1L;
	@Autowired
	private transient PagedListWrapper<Moneda> plwMoneda;
	private MyListbox monedaList;
	private Paging pagingMoneda;
	private Textbox txtNombre;
	private Textbox txtEquivalencia;
	private Row rowEquivalencia;
	private Listheader headerEquivalencia;

	public Paging getPagingMoneda() {
		return pagingMoneda;
	}

	public void setPagingMoneda(Paging pagingMoneda) {
		this.pagingMoneda = pagingMoneda;
	}

	public MyListbox getMonedaList() {
		return monedaList;
	}

	public void setMonedaList(MyListbox monedaList) {
		this.monedaList = monedaList;
	}

	public PagedListWrapper<Moneda> getPlwMoneda() {
		return plwMoneda;
	}

	public void setPlwMoneda(PagedListWrapper<Moneda> plwMoneda) {
		this.plwMoneda = plwMoneda;
	}

	public Textbox getTxtEquivalencia() {
		return txtEquivalencia;
	}

	public void setTxtEquivalencia(Textbox txtEquivalencia) {
		this.txtEquivalencia = txtEquivalencia;
	}

	public Textbox getTxtNombre() {
		return txtNombre;
	}

	public void setTxtNombre(Textbox txtNombre) {
		this.txtNombre = txtNombre;
	}

	public Listheader getHeaderEquivalencia() {
		return headerEquivalencia;
	}

	public void setHeaderEquivalencia(Listheader headerEquivalencia) {
		this.headerEquivalencia = headerEquivalencia;
	}

	public Row getRowEquivalencia() {
		return rowEquivalencia;
	}

	public void setRowEquivalencia(Row rowEquivalencia) {
		this.rowEquivalencia = rowEquivalencia;
	}

	public void onClick$btnPesquisa(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnRefresh(Event ev) throws InterruptedException {
		refreshLista();
	}

	public void onClick$btnNovo(Event ev) {
		verPeriodo(new Moneda());
	}

	@Override
	public void doAfterCompose(Component comp) throws Exception {
		super.doAfterCompose(comp);

		monedaList.setItemRenderer(new RenderMoneda());
		monedaList.addEventListener("onDoubleClick", new EventListener() {

			@Override
			public void onEvent(Event event) throws Exception {
				Moneda c = (Moneda) monedaList.getSelected();
				verPeriodo(c);
			}
		});

		refreshLista();

		if (!ApplicationProperties.getInstance().mostrarEquivalencia()) {
			rowEquivalencia.setVisible(Boolean.FALSE);
			headerEquivalencia.setVisible(Boolean.FALSE);
		}

		txtNombre.focus();
	}

	private void verPeriodo(Moneda c) {
		if (c == null) {
			return;
		}

		Map args = new HashMap();
		args.put("busquedaMonedaController", this);
		args.put("moneda", c);
		args.put("monedaList", monedaList);

		openWindow("/gui/catalogos/editarMoneda.zul",
				Labels.getLabel("editarMonedaController.window.title"), args, MODAL);
	}

	public void refreshLista() throws InterruptedException {
		HibernateSearchObject<Moneda> monedaBusqueda =
				new HibernateSearchObject<Moneda>(Moneda.class, pagingMoneda.getPageSize());

		monedaBusqueda.addFilterLike("descmoneda", "%" + txtNombre.getText().trim().concat("%"));
		if (!txtEquivalencia.getText().isEmpty()) {
			monedaBusqueda.addFilterLike("equivalenciaId", txtEquivalencia.getText().trim().concat("%"));
		}

		monedaBusqueda.addFilterEqual("activo", Boolean.TRUE);
		monedaBusqueda.addSortAsc("descmoneda");
		monedaBusqueda.addFilterNotEqual("monedaId", -1);

		plwMoneda.init(monedaBusqueda, monedaList, pagingMoneda);

		if (monedaList.getData().length == 0) {
			Messagebox.show(
					Labels.getLabel("MSG.ningunRegistro"),
					Labels.getLabel("busquedaMonedaController.window.title"),
					Messagebox.OK, Messagebox.INFORMATION);
		}
	}
}
